/*****************************************************************************************
 Copyright (c) 2002 The UbixOS Project
 All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of
conditions, the following disclaimer and the list of authors.  Redistributions in binary
form must reproduce the above copyright notice, this list of conditions, the following
disclaimer and the list of authors in the documentation and/or other materials provided
with the distribution. Neither the name of the UbixOS Project nor the names of its
contributors may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id$

*****************************************************************************************/

#include <ubixos/exec.h>
#include <ubixos/sched.h>
#include <ubixos/ld.h>
#include <vmm/vmm.h>
#include <lib/kmalloc.h>
#include <lib/kprintf.h>

/*****************************************************************************************

 Function:   execThread(void (*)(void),int,char *);
 Description: This function will create a thread from code in the current memory space

 Notes:
 
 05/19/04 - This does not work the way I want it to it still makes a copy of kernel space
            so do not use out side of kernel space

*****************************************************************************************/
uInt32 execThread(void (* tproc)(void),int stack,char *arg) {
  kTask_t * newProcess;
  /* Find A New Thread */
  newProcess = schedNewTask();

  /* Set All The Correct Thread Attributes */
  newProcess->tss.back_link    = 0x0;
  newProcess->tss.esp0         = 0x0;
  newProcess->tss.ss0          = 0x0;
  newProcess->tss.esp1         = 0x0;
  newProcess->tss.ss1          = 0x0;
  newProcess->tss.esp2         = 0x0;
  newProcess->tss.ss2          = 0x0;
  newProcess->tss.cr3          = (unsigned int)kernelPageDirectory;
  newProcess->tss.eip          = (unsigned int)tproc;
  newProcess->tss.eflags       = 0x206;
  newProcess->tss.esp          = stack;
  newProcess->tss.ebp          = stack;
  newProcess->tss.esi          = 0x0;
  newProcess->tss.edi          = 0x0;

  newProcess->tss.es           = 0x10;
  newProcess->tss.cs           = 0x08;
  newProcess->tss.ss           = 0x10;
  newProcess->tss.ds           = 0x10;
  newProcess->tss.fs           = 0x10;
  newProcess->tss.gs           = 0x10;
  newProcess->tss.ldt          = 0x18;

  newProcess->tss.trace_bitmap = 0x0000;
  newProcess->tss.io_map       = 0x8000;
  newProcess->oInfo.vmStart    = 0x6400000;

  /* Set up default stack for thread here filled with arg list 3 times */
  asm volatile(
    "pusha               \n"
    "movl   %%esp,%%ecx  \n"
    "movl   %1,%%eax     \n"
    "movl   %%eax,%%esp  \n"
    "pushl  %%ebx        \n"
    "pushl  %%ebx        \n"
    "pushl  %%ebx        \n"
    "movl   %%esp,%%eax  \n"
    "movl   %%eax,%1     \n"
    "movl   %%ecx,%%esp  \n"
    "popa                \n"
    :
    : "b" (arg),"m" (newProcess->tss.esp)
    );

  /* Put new thread into the READY state */
  newProcess->state = READY;

  /* Return with the new process ID */
  return((uInt32)newProcess);
  }

/*****************************************************************************************

 Function: void execFile(char *file);
 Description: This Function Executes A Kile Into A New VM Space With Out
              Having To Fork
 Notes:

 07/30/02 - I Have Made Some Heavy Changes To This As Well As Fixed A Few
            Memory Leaks The Memory Allocated To Load The Binary Into Is
            Now Unmapped So It Can Be Used Again And Not Held Onto Until
            The Program Exits

 07/30/02 - Now I Have To Make A Better Memory Allocator So We Can Set Up
            The Freshly Allocated Pages With The Correct Permissions

*****************************************************************************************/
void execFile(char *file,int argc,char **argv,int console) {

  int     i      = 0x0;
  int     x      = 0x0;
  uInt32  eStart = 0x0;
  char   *newLoc = 0x0;
  char   *linker = 0x0;

  fileDescriptor   *tmpFd         = 0x0;
  elfHeader        *binaryHeader  = 0x0;
  elfProgramheader *programHeader = 0x0;

  /* Get A New Task For This Proccess */
  _current = schedNewTask();
  _current->gid = 0;
  _current->uid = 0;

  /* Now We Must Create A Virtual Space For This Proccess To Run In */
  _current->tss.cr3 = (uInt32)vmmCreateVirtualSpace(_current->id);

  /* To Better Load This Application We Will Switch Over To Its VM Space */
  asm(
    "movl %0,%%eax          \n"
    "movl %%eax,%%cr3       \n"
    : : "d" ((uInt32 *)(_current->tss.cr3))
    );

  /* Lets Find The File */
  tmpFd = fopen(file,"r");

  /* If We Dont Find the File Return */
  if (!tmpFd) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    fclose(tmpFd);
    return;
    }
  if (tmpFd->perms == 0) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    fclose(tmpFd);
    return;
    }

  /* Load ELF Header */
  binaryHeader = (elfHeader *)kmalloc(sizeof(elfHeader));
  fread(binaryHeader,sizeof(elfHeader),1,tmpFd);


  /* Check If App Is A Real Application */
  if ((binaryHeader->eIdent[1] != 'E') && (binaryHeader->eIdent[2] != 'L') && (binaryHeader->eIdent[3] != 'F')) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }
  else if (binaryHeader->eType != 2) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }
  else if (binaryHeader->eEntry == 0x300000) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }

  /* Load The Program Header(s) */
  programHeader = (elfProgramheader *)kmalloc(sizeof(elfProgramheader)*binaryHeader->ePhnum);
  fseek(tmpFd,binaryHeader->ePhoff,0);
  fread(programHeader,(sizeof(elfProgramheader)*binaryHeader->ePhnum),1,tmpFd);

  kprintf("1");

  /* Loop Through The Header And Load Sections Which Need To Be Loaded */
  for (i=0;i<binaryHeader->ePhnum;i++) {
    kprintf(".");
    if (programHeader[i].phType == 1) {
      kprintf("z");
      newLoc = (char *)programHeader[i].phVaddr;
      /*
      Allocate Memory Im Going To Have To Make This Load Memory With Correct
      Settings so it helps us in the future
      */
      for (x=0;x<=((programHeader[i].phMemsz & 0xFFFFF000)+4095);x += 0x100) {
        if (vmmRemapPage(vmmFindFreePage(_current->id),((programHeader[i].phVaddr & 0xFFFFF000) + x)) == 0x0) {
          kpanic("Error: vmmFindFreePage Failed\n");
          }
        }
      _current->oInfo.vmStart = ((programHeader[i].phVaddr & 0xFFFFF000) + 0x1900000);
      /* Now Load Section To Memory */
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread(newLoc,programHeader[i].phFilesz,1,tmpFd);
      }
    else if (programHeader[i].phType == 2) {
      kprintf("x");
      newLoc = (char *)programHeader[i].phVaddr;
      //elfDynamicS = (elfDynamic *)programHeader[i].phVaddr;
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread(newLoc,programHeader[i].phFilesz,1,tmpFd);
      }
    else if (programHeader[i].phType == 3) {
      kprintf("c");
      linker = (char *)kmalloc(programHeader[i].phMemsz);
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread(linker,programHeader[i].phFilesz,1,tmpFd);
      }
    }

  kprintf("2");

  /* Set Virtual Memory Start */
  _current->oInfo.vmStart = ((programHeader[i].phVaddr & 0xFFFFF000) + 0x1900000);
  /* Get The Starting Point */
  eStart = binaryHeader->eEntry;

  /* Now Lets Make A Clean Stack */
  newLoc = (char *)0x5DB000;
  vmmRemapPage(vmmFindFreePage(_current->id),0x5DC000);
  vmmSetPageAttribute(0x5DC000,(pageDefault | pageStack));
  vmmRemapPage(vmmFindFreePage(_current->id),0x5DB000);
  vmmSetPageAttribute(0x5DB000,(pageDefault | pageStack));
  vmmRemapPage(vmmFindFreePage(_current->id),0x5DA000);
  vmmSetPageAttribute(0x5DA000,(pageDefault | pageStack));
  vmmRemapPage(vmmFindFreePage(_current->id),0x5D9000);
  vmmSetPageAttribute(0x5D9000,(pageDefault | pageStack));

  i = 0x5DD000;

  vmmRemapPage(vmmFindFreePage(_current->id),0x5D3000);
  vmmSetPageAttribute(0x5D3000,(pageDefault | pageStack));
  vmmRemapPage(vmmFindFreePage(_current->id),0x5D2000);
  vmmSetPageAttribute(0x5D2000,(pageDefault | pageStack));
  vmmRemapPage(vmmFindFreePage(_current->id),0x5D1000);
  vmmSetPageAttribute(0x5D1000,(pageDefault | pageStack));
  vmmRemapPage(vmmFindFreePage(_current->id),0x5D0000);
  vmmSetPageAttribute(0x5D0000,(pageDefault | pageStack));

  /* Set All The Proper Information For The Task */
  _current->tss.back_link    = 0x0;
  _current->tss.esp0         = 0x5D4000;
  _current->tss.ss0          = 0x10;
  _current->tss.esp1         = 0x0;
  _current->tss.ss1          = 0x0;
  _current->tss.esp2         = 0x0;
  _current->tss.ss2          = 0x0;
  _current->tss.eip          = (long)eStart;
  _current->tss.eflags       = 0x206;
  _current->tss.esp          = i-12;
  _current->tss.ebp          = i;
  _current->tss.esi          = 0x0;
  _current->tss.edi          = 0x0;

  /* Set these up to be ring 3 tasks */
  _current->tss.es           = 0x30+3;
  _current->tss.cs           = 0x28+3;
  _current->tss.ss           = 0x30+3;
  _current->tss.ds           = 0x30+3;
  _current->tss.fs           = 0x30+3;
  _current->tss.gs           = 0x30+3;

  _current->tss.ldt          = 0x18;
  _current->tss.trace_bitmap = 0x0000;
  _current->tss.io_map       = 0x8000;
  _current->state            = READY;

 /* Set up the defaault stack to be used by this new process */
 /*
 
 Some bug here let me figure it out 05/19/2004

 asm volatile(
    "pusha               \n"
    "movl   %%esp,%%edx  \n"
    "movl   %2,%%ecx     \n"
    "movl   %%ecx,%%esp  \n"
    "pushl  $0x0         \n"
    "pushl  $0x0         \n"
    "pushl  $0x0         \n"
    "pushl  $0x0         \n"
    "pushl  %%ebx        \n"
    "pushl  %%eax        \n"
    "movl   %%esp,%%ecx  \n"
    "movl   %%ecx,%2     \n"
    "movl   %%edx,%%esp  \n"
    "popa                \n"
    :
    : "a" (argc), "b" (argv), "m" (_current->tss.esp)
    );
  */

  kfree(binaryHeader);
  kfree(programHeader);
  fclose(tmpFd);

  /* Switch Back To The Kernels VM Space */
  asm(
    "movl %0,%%eax          \n"
    "movl %%eax,%%cr3       \n"
    : : "d" ((uInt32 *)(kernelPageDirectory))
    );
  /* Finally Return */
  return;
  }

/*****************************************************************************************

 Function: void sysExec();
 Description: This Is The System Call To Execute A New Task

 Notes:
 04-22-03 - It Now Loads Sections Not The Full File

*****************************************************************************************/
void sysExec(char *file,int argc,char **argv) {
  int    i            = 0x0;
  int    x            = 0x0;
  uInt32 eStart       = 0x0;
  uInt32 *tmp         = 0x0;
  char   *newLoc      = 0x0;
  char   *linker      = 0x0;

  fileDescriptor   *tmpFd         = 0x0;
  elfHeader        *binaryHeader  = 0x0;
  elfProgramheader *programHeader = 0x0;
  elfSectionheader *sectionHeader = 0x0;
  elfDynamic       *elfDynamicS   = 0x0;


  tmpFd = fopen(file,"r");

  /* If We Dont Find the File Return */
  if (tmpFd == 0x0) {
    return;
    }
  if (tmpFd->perms == 0) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    fclose(tmpFd);
    return;
    }

  /* Load ELF Header */
  binaryHeader = (elfHeader *)kmalloc(sizeof(elfHeader));
  fread(binaryHeader,sizeof(elfHeader),1,tmpFd);
  /* Set sectionHeader To Point To Loaded Binary To We Can Gather Info */
  /* sectionHeader = (elfSectionheader *)(0x7C0000 + binaryHeader->eShoff); */

  /* Check If App Is A Real Application */
  if ((binaryHeader->eIdent[1] != 'E') && (binaryHeader->eIdent[2] != 'L') && (binaryHeader->eIdent[3] != 'F')) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }
  else if (binaryHeader->eType != 2) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }
  else if (binaryHeader->eEntry == 0x300000) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }

  /* Load The Program Header(s) */
  programHeader = (elfProgramheader *)kmalloc(sizeof(elfProgramheader)*binaryHeader->ePhnum);
  fseek(tmpFd,binaryHeader->ePhoff,0);
  fread(programHeader,(sizeof(elfProgramheader)*binaryHeader->ePhnum),1,tmpFd);

  sectionHeader = (elfSectionheader *)kmalloc(sizeof(elfSectionheader)*binaryHeader->eShnum);
  fseek(tmpFd,binaryHeader->eShoff,0);
  fread(sectionHeader,sizeof(elfSectionheader)*binaryHeader->eShnum,1,tmpFd);

  /* Loop Through The Header And Load Sections Which Need To Be Loaded */
  for (i=0;i<binaryHeader->ePhnum;i++) {
    if (programHeader[i].phType == 1) {
      newLoc = (char *)programHeader[i].phVaddr;
      /*
      Allocate Memory Im Going To Have To Make This Load Memory With Correct
      Settings so it helps us in the future
      */
      for (x=0;x<=((programHeader[i].phMemsz & 0xFFFFF000)+4095);x+=4096) {
        vmmRemapPage(vmmFindFreePage(_current->id),((programHeader[i].phVaddr & 0xFFFFF000) + x));
        }
      _current->oInfo.vmStart = ((programHeader[i].phVaddr & 0xFFFFF000) + 0x1900000);
      /* Now Load Section To Memory */
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread(newLoc,programHeader[i].phFilesz,1,tmpFd);
      }
    else if (programHeader[i].phType == 2) {
      newLoc = (char *)programHeader[i].phVaddr;
      elfDynamicS = (elfDynamic *)programHeader[i].phVaddr;
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread(newLoc,programHeader[i].phFilesz,1,tmpFd);
      }
    else if (programHeader[i].phType == 3) {
      linker = (char *)kmalloc(programHeader[i].phMemsz);
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread(linker,programHeader[i].phFilesz,1,tmpFd);
      }
    }
  _current->oInfo.shstrtab = (char *)kmalloc(sectionHeader[binaryHeader->eShstrndx].shSize);
  fseek(tmpFd,sectionHeader[binaryHeader->eShstrndx].shOffset,0);
  fread(_current->oInfo.shstrtab,sectionHeader[binaryHeader->eShstrndx].shSize,1,tmpFd);

  for (i=0;i<12;i++) {
    if (elfDynamicS[i].dynVal == 0x3) {
      tmp = (uInt32 *)elfDynamicS[i].dynPtr;
      tmp[2] = (uInt32) &ld;
      }
    }

  _current->oInfo.sectionHeader = sectionHeader;
  _current->oInfo.sectionCount  = binaryHeader->eShnum;
  _current->oInfo.stringSection = binaryHeader->eShstrndx;

  /* Get The Starting Point */
  eStart = binaryHeader->eEntry;

  /* Now That We Relocated The Binary We Can Unmap And Free Header Info */
  kfree(binaryHeader);
  kfree(programHeader);
  fclose(tmpFd);
  /* Jump To Start Of New Binary */
  asm volatile(
    "pushl  %1     \n"
    "pushl  %%eax  \n"
    "call  *%0     \n"
    :
    : "g" (eStart),"g" (argv),"a" (argc)
    );
  }

/***
 $Log$
 Revision 1.12  2004/05/22 21:46:37  reddawg
 Fixed some bugs

 Revision 1.11  2004/05/22 02:10:42  reddawg
 Added Code To Debug ISsue

 Revision 1.10  2004/05/21 21:15:04  reddawg
 Fixed a few bugs which prevented the system from loadin

 Revision 1.9  2004/05/21 15:34:23  reddawg
 Fixed a couple of typo

 Revision 1.8  2004/05/21 15:32:06  reddawg
 Changed the sys fileExec works it just loads sections needed now instead of fully should be a performance increase of about 40%

 Revision 1.7  2004/05/19 04:31:12  reddawg
 Fixed some typedef problems in exec

 Revision 1.6  2004/05/19 04:07:42  reddawg
 kmalloc(size,pid) no more it is no kmalloc(size); the way it should of been

 Revision 1.5  2004/05/19 01:21:29  reddawg
 Tweaked

 Revision 1.4  2004/05/15 02:30:28  reddawg
 Lots of changes

 Revision 1.3  2004/05/02 03:19:51  reddawg
 Added Spinlock Provision For SMP

 Revision 1.2  2004/04/30 14:16:04  reddawg
 Fixed all the datatypes to be consistant uInt8,uInt16,uInt32,Int8,Int16,Int32

 Revision 1.1.1.1  2004/04/15 12:07:18  reddawg
 UbixOS v1.0

 Revision 1.44  2004/04/13 16:16:44  reddawg
 Changed our copyright, it is all now under a BSD-Style license

 END
 ***/
